#!/bin/env Rscript

sorted_ED_N_head <- function(ccED,N_head,N_d_copy,oEDsum,loci_order,N_head_cc) {
  N_loci       = length(ccED)
  ij           = N_head
  ij_loci      = 0
  ij_loci_name = 0
  if (N_loci > 1) {
    for (i in 1:N_loci) {
      ccEDi  = ccED[[i]]$ED[oEDsum]
      N_ccEDi = length(ccEDi)
      for (j in 1:N_ccEDi) {
        if (sum(ccEDi[1:j]) >= N_d_copy) {
          break
        }
      }
      if (ij >= j) {
        ij           = j
        ij_loci      = i
        ij_loci_name = names(ccED)[i]
      }
    }
    if (ij_loci != 0) {
      N_head     = N_head - ij
      loci_order = c(loci_order,ij_loci_name)
      N_head_cc  = c(N_head_cc,as.character(ccED[[ij_loci]]$cc[oEDsum][1:ij]))
      ccED       = ccED[-ij_loci]
      oEDsum     = oEDsum[-c(1:ij)]
      sorted_ED_N_head(ccED,N_head,N_d_copy,oEDsum,loci_order,N_head_cc)
    } else {
      loci_order      = c(loci_order,names(ccED)[1])
      re_N_head_cc    = c(N_head_cc,as.character(ccED[[1]]$cc[oEDsum][1:ij]))
      re_min_N_d_copy = length(N_head_cc) + j
      re              = list('N_head_cc'=re_N_head_cc,'min_N_d_copy'=re_min_N_d_copy)
      re
    }
  } else {
    ccEDi   = ccED[[1]]$ED[oEDsum]
    N_ccEDi = length(ccEDi)
    for (j in 1:N_ccEDi) {
      if (sum(ccEDi[1:j]) >= N_d_copy) {
        break
      }
    }
    if (ij >= j) {
      ij           = j
      ij_loci      = 1
      ij_loci_name = names(ccED)[1]
    }
    if (ij_loci != 0) {
      N_head          = N_head - ij
      loci_order      = c(loci_order,ij_loci_name)
      N_head_cc       = c(N_head_cc,as.character(ccED[[ij_loci]]$cc[oEDsum][1:ij]))
      if (N_head != 0) {
        re_N_head_cc    = c(N_head_cc,as.character(ccED[[ij_loci]]$cc[oEDsum][ij+1:N_head]))
      } else {
        re_N_head_cc    = N_head_cc
      }
      re_min_N_d_copy = length(N_head_cc)
      re              = list('N_head_cc'=re_N_head_cc,'min_N_d_copy'=re_min_N_d_copy)
      re
    } else {
      loci_order      = c(loci_order,names(ccED)[1])
      re_N_head_cc    = c(N_head_cc,as.character(ccED[[1]]$cc[oEDsum][1:ij]))
      re_min_N_d_copy = length(N_head_cc) + j
      re              = list('N_head_cc'=re_N_head_cc,'min_N_d_copy'=re_min_N_d_copy)
      re
    }
  }
}

paramFileTemp <- function(file,N_head,N_d_copy) {
  data   = read.table(file,header=TRUE)
  N_loci = (length(names(data))-4)/2
  cc     = data$sampleID
  a_sum  = data$a_sum
  ED_sum = data$ED_sum
  for (i in 1:N_loci) {
    EDi          = paste("ED_",i,sep="")
    EDi_data     = data[EDi]
    ccEDi        = data.frame(cc,EDi_data)
    names(ccEDi) = c('cc','ED')
    if (i == 1) {
      ccED      = list(ccEDi)
    } else {
      ccED[[i]] = ccEDi
    }
  }
  names(ccED) = c(1:N_loci)
  oEDsum      = order(ED_sum,decreasing = TRUE)
  loci_order  = NULL
  N_head_cc   = NULL
  sorted_ED   = sorted_ED_N_head(ccED,N_head,N_d_copy,oEDsum,loci_order,N_head_cc)
  re          = list('N_loci'=N_loci,'sorted_E'=sorted_ED$N_head_cc,'min_samples_N_d_copy'=sorted_ED$min_N_d_copy)
  re
}

expected <- function(file,N_head,N_d_copy) {
  string       = paste("Read in file: ",file,sep="")
  re           = paramFileTemp(file,N_head,N_d_copy)
  topID        = re$sorted_E
  topID_ED_sum = rep(0,N_head)
  fdata        = read.table(file,header=TRUE)
  fsampleID    = fdata$sampleID
  for (i in 1:N_head) {
    topID_ED_sum[i] = fdata$ED_sum[fsampleID==topID[i]]
  }
  out          = data.frame(sampleID=topID,ED_sum=topID_ED_sum)
  string       = paste("IDs of the",N_head,"selected subjects are in:")
  wLEFT        = paste("top",N_head,"ID.txt",sep="")
  message(paste(string,wLEFT))
  write.table(out,file=wLEFT,sep="\t",row.names=FALSE,quote=FALSE)
  string = paste("Warning:",re$min_samples_N_d_copy,"samples are needed to have >=",N_d_copy,"disease variants per region.")
  message(string)
}

args <- commandArgs(TRUE)

verbose  = TRUE
file     = args[1]             # "./expected.txt"
N_head   = as.numeric(args[2]) # 50
N_d_copy = as.numeric(args[3]) # 10


expected(file,N_head,N_d_copy)
